Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1504825 - Review Request: R-RColorBrewer - Provides color schemes for maps (and other graphics)
Summary: Review Request: R-RColorBrewer - Provides color schemes for maps (and other g...
Keywords:
Status: CLOSED DUPLICATE of bug 1622331
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-DEADREVIEW
TreeView+ depends on / blocked
 
Reported: 2017-10-20 17:45 UTC by Bill Crawford
Modified: 2018-08-26 11:13 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-08-23 09:26:44 UTC


Attachments (Terms of Use)

Description Bill Crawford 2017-10-20 17:45:40 UTC
Spec URL: https://drive.google.com/open?id=0Bx2IC-5Vi3QVVGpXT1pmZy1rZkE
SRPM URL: https://drive.google.com/open?id=0Bx2IC-5Vi3QVcHlKaEF3THNGNU0
Description: Provides color schemes for maps (and other graphics) designed by Cynthia Brewer as described at http://colorbrewer2.org
Fedora Account System Username: willc

Comment 1 Bill Crawford 2017-10-20 17:47:49 UTC
Please let me know if the Google Drive URLs cause any problems. Most reviews I've looked at host the spec and srpm on Fedora People, but I don't have access to that yet :)

Comment 2 david08741 2017-12-04 17:06:56 UTC
Do you have access to copr?

I cannot download the file with wget ...

Comment 3 Bill Crawford 2017-12-04 17:33:04 UTC
Oh! Yes, I've put a bunch of packages at https://copr.fedorainfracloud.org/coprs/willc/r-packages/ ...

Comment 4 david08741 2017-12-04 18:59:43 UTC
Full links would have been nice ;)

Spec URL: https://copr-be.cloud.fedoraproject.org/results/willc/r-packages/fedora-rawhide-x86_64/00649767-R-RColorBrewer/R-RColorBrewer.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/willc/r-packages/fedora-rawhide-x86_64/00649767-R-RColorBrewer/R-RColorBrewer-1.1.2-1.fc28.src.rpm

Use an apropriate license: https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing , I guess ASL 2.0

Note this is not an official review:


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package have the default element marked as %%doc :DESCRIPTION
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file COPYING is not marked as %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License name not appropriate - see https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache (v2.0)". 6 files
     have unknown license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[?]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[?]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[?]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

R:
[x]: Package contains the mandatory BuildRequires.
[x]: The package has the standard %install section.
[x]: Package requires R-core.

===== SHOULD items =====

Generic:
[!]: Buildroot is not present
     Note: Buildroot: present but not needed
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

R:
[!]: The %check macro is present
     Test should be moved to check section
[x]: Latest version is packaged.
     Note: Latest upstream version is 1.1.2, packaged version is 1.1.2

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: R-RColorBrewer-1.1.2-1.fc24.noarch.rpm
          R-RColorBrewer-1.1.2-1.fc24.src.rpm
R-RColorBrewer.noarch: W: invalid-license Apache License 2.0
R-RColorBrewer.noarch: W: wrong-file-end-of-line-encoding /usr/share/R/library/RColorBrewer/COPYING
R-RColorBrewer.src: W: invalid-license Apache License 2.0
R-RColorBrewer.src:27: W: macro-in-comment %{buildroot}
2 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
R-RColorBrewer.noarch: W: invalid-license Apache License 2.0
R-RColorBrewer.noarch: W: invalid-url URL: http://cran.r-project.org/web/packages/RColorBrewer/index.html <urlopen error [Errno -2] Name or service not known>
R-RColorBrewer.noarch: W: wrong-file-end-of-line-encoding /usr/share/R/library/RColorBrewer/COPYING
1 packages and 0 specfiles checked; 0 errors, 3 warnings.




Requires
--------
R-RColorBrewer (rpmlib, GLIBC filtered):
    R-core



Provides
--------
R-RColorBrewer:
    R-RColorBrewer



Source checksums
----------------
http://cran.r-project.org/src/contrib/RColorBrewer_1.1-2.tar.gz :
  CHECKSUM(SHA256) this package     : f3e9781e84e114b7a88eb099825936cc5ae7276bbba5af94d35adb1b3ea2ccdd
  CHECKSUM(SHA256) upstream package : f3e9781e84e114b7a88eb099825936cc5ae7276bbba5af94d35adb1b3ea2ccdd


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -n R-RColorBrewer
Buildroot used: fedora-24-x86_64
Active plugins: Generic, R, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 5 Robert-André Mauchin 2017-12-04 19:52:46 UTC
As David said:

 - Use an apropriate license: https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing , I guess ASL 2.0

 - If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file COPYING is not marked as %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text

→ You installed the COPYING file with the %doc macro but it should be with %license instead:

%license %{rlibdir}/RColorBrewer/COPYING

- [?]: Each %files section contains %defattr if rpm < 4.4
       Note: %defattr present but not needed

→ You should remove:

%defattr(-, root, root, -)

 - Also not needed:

#Group:            Applications/Engineering

#rm -rf %{buildroot}

 - [!]: Buildroot is not present
   Note: Buildroot: present but not needed

→ Remove:

BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


 - [!]: Package has no %clean section with rm -rf %{buildroot} (or
        $RPM_BUILD_ROOT)

→ Remove:

%clean
rm -rf %{buildroot}


 - For R package you should at the very least have a %check like this:

%check
%{_bindir}/R CMD check %{packname}



Also you'll need a sponsor, I'm not able to sponsor but I suggest introducing yourself on the fedora-devel mailing lists and do a few informal review like David did for you to show you understand the Fedora Packaging Guidelines.

Comment 6 Bill Crawford 2017-12-05 00:17:04 UTC
SPEC: https://copr-be.cloud.fedoraproject.org/results/willc/r-packages/fedora-26-x86_64/00684361-R-RColorBrewer/R-RColorBrewer.spec
SRPM: https://copr-be.cloud.fedoraproject.org/results/willc/r-packages/fedora-26-x86_64/00684361-R-RColorBrewer/R-RColorBrewer-1.1.2-2.fc26.src.rpm

The R "check" gives two NOTEs, as follows:

* checking DESCRIPTION meta-information ... NOTE
Malformed Description field: should contain one or more complete sentences.

- This seems slightly unreasonable, since it looks like a good enough sentence to me, but since it ends in a URL, adding a period might break it :o)

* checking R code for possible problems ... NOTE
brewer.pal: no visible global function definition for 'rgb'
display.brewer.all: no visible global function definition for 'par'
display.brewer.all: no visible global function definition for 'plot'
display.brewer.all: no visible global function definition for 'rect'
display.brewer.all: no visible global function definition for 'text'
display.brewer.pal: no visible global function definition for 'image'
Undefined global functions or variables:
  image par plot rect rgb text
Consider adding
  importFrom("grDevices", "rgb")
  importFrom("graphics", "image", "par", "plot", "rect", "text")
to your NAMESPACE file.

- the package appears to work well despite these alarming warnings; running {{{
    library("RColorBrewer");
    display.brewer.all();
}}} works with no visible errors ...

Is it worth pestering upstream about these? Seems like it might be impolitic to say the least...

Comment 8 Elliott Sales de Andrade 2018-03-19 06:18:11 UTC
Upstream should have seen these warnings when submitting to CRAN [1], but I guess you could try to pester them anyway. The package hasn't been touched since 2014 though.

Were you able to find a sponsor yet (I cannot help with that, sorry)?

[1] https://cran.r-project.org/web/checks/check_results_RColorBrewer.html

Comment 9 Elliott Sales de Andrade 2018-04-27 22:37:47 UTC
Are you still interested in packaging this?

Comment 10 Bill Crawford 2018-05-04 15:34:19 UTC
Oh! Yes (sorry). I got interested in other things but would still like to get this in (and a bunch of others). I started learning a bit of R, and found the majority of packages I wanted to use (e.g. treemap) weren't in the repo, and it looked like it would be *fairly* easy to package them, so I did (see copr).

Comment 11 Elliott Sales de Andrade 2018-05-10 18:04:15 UTC
Have you found a sponsor? Please do as Robert-Andre suggests and review some other packages and introduce yourself on the mailing list.

Comment 12 Iñaki Ucar 2018-08-16 09:38:06 UTC
This ticket is stalled, and it is blocking the submission of other important dependent packages, so a response is needed. Following the policy for stalled package reviews (https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews), if there is no response within a week, this ticket will be closed and another packager may submit this in a separate bug.

Comment 13 Iñaki Ucar 2018-08-23 09:26:44 UTC
(In reply to Iñaki Ucar from comment #12)
> This ticket is stalled, and it is blocking the submission of other important
> dependent packages, so a response is needed. Following the policy for
> stalled package reviews
> (https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews), if
> there is no response within a week, this ticket will be closed and another
> packager may submit this in a separate bug.

Closing this.

Comment 14 Iñaki Ucar 2018-08-26 11:13:54 UTC

*** This bug has been marked as a duplicate of bug 1622331 ***


Note You need to log in before you can comment on or make changes to this bug.